SystemOrganization addCategory: #'Glamour-Core'!

Announcer subclass: #GLMPane
	instanceVariableNames: 'browser name presentations ports'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMPane classSide methodsFor: 'private' stamp: ' 25/2/09 11:51'!
portClass 
	 
	^GLMPanePort! !

!GLMPane methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
addPresentation: aPresentation 
	 
	self 
		notingPresentationChangeDo: 
			[self presentations 
				addLast: 
					(aPresentation 
						pane: self; 
						yourself)]! !

!GLMPane methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
addPresentations: aCollection 
	 
	self 
		notingPresentationChangeDo: 
			[aCollection 
				do: 
					[:each |  
					self presentations 
						addLast: 
							(each 
								pane: self; 
								yourself)]]! !

!GLMPane methodsFor: 'converting' stamp: ' 25/2/09 11:51'!
asGlamorousPane 
	 
	^self! !

!GLMPane methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
browser 
	 
	^browser! !

!GLMPane methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
browser: aBrowser 
	 
	browser := aBrowser! !

!GLMPane methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
clear 
	 
	self notingPresentationChangeDo: [presentations := nil]. 
	self ports do: [:each | each value: nil]! !

!GLMPane methodsFor: 'testing' stamp: ' 25/2/09 11:51'!
hasBrowser 
	 
	^self browser isNil not! !

!GLMPane methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
matchingPresentations 
	 
	^self presentations select: [:each | each matches]! !

!GLMPane methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
name 
	 
	^name! !

!GLMPane methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
name: aSymbol 
	 
	name := aSymbol! !

!GLMPane methodsFor: 'private' stamp: ' 25/2/09 11:51'!
notingPresentationChangeDo: aBlock 
	 
	| oldPresentations oldMatchingPresentations | 
	oldPresentations := self presentations copy. 
	oldMatchingPresentations := self matchingPresentations. 
	aBlock value. 
	self presentations ~= oldPresentations 
		ifTrue: 
			[self 
				announce: 
					((GLMPresentationsChanged new) 
						pane: self; 
						oldPresentations: oldPresentations; 
						yourself)]. 
	self matchingPresentations ~= oldMatchingPresentations 
		ifTrue: 
			[self 
				announce: 
					((GLMMatchingPresentationsChanged new) 
						pane: self; 
						oldMatchingPresentations: oldMatchingPresentations; 
						yourself)]! !

!GLMPane methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
port: aSymbol 
	 
	^self ports 
		detect: [:each | each name = aSymbol] 
		ifNone: 
			[self ports 
				addLast: 
					((self class portClass new) 
						pane: self; 
						name: aSymbol; 
						yourself)]! !

!GLMPane methodsFor: 'private' stamp: ' 25/2/09 11:51'!
portEvent: aPortEvent 
	 
	self hasBrowser ifTrue: [self browser innerPortEvent: aPortEvent]. 
	self presentations do: [:each | each outerPortEvent: aPortEvent]! !

!GLMPane methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
ports 
	 
	^ports ifNil: [ports := OrderedCollection new]! !

!GLMPane methodsFor: 'private' stamp: ' 25/2/09 11:51'!
postCopy 
	 
	super postCopy! !

!GLMPane methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
presentations 
	 
	^presentations ifNil: [presentations := OrderedCollection new]! !

!GLMPane methodsFor: 'rendering' stamp: ' 25/2/09 11:51'!
renderGlamorouslyOn: aRenderer 
	 
	^aRenderer renderPane: self! !

!GLMPane methodsFor: 'announcements' stamp: ' 25/2/09 11:51'!
whenMatchingPresentationsChanged: aBlock 
	 
	^self when: GLMMatchingPresentationsChanged do: aBlock! !

!GLMPane methodsFor: 'announcements' stamp: ' 25/2/09 11:51'!
whenPresentationsChanged: aBlock 
	 
	^self when: GLMPresentationsChanged do: aBlock! !

Announcer subclass: #GLMPresentation
	instanceVariableNames: 'pane title transformation actions condition isInspectable implicitNotNil'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

GLMPresentation subclass: #GLMBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMBrowser commentStamp: '<historical>' prior: 0!
Browsers are one of the core components in Glamour.

They contain panes and transmission between them, which can either be explicitely defined by the user (such as in the TableLayoutBrowser) or implicitely defined (such as in the Finder).

Browsers serve as composition managers. They determine when and under which conditions transmissions should be triggered and how they connect the ports of panes. In return, panes inform the browsers when event occur on their ports so that the browser can make an informed decission on what to do.!

!GLMBrowser methodsFor: 'scripting-private' stamp: ' 25/2/09 11:51'!
initializeScriptingDefaults 
	"Initialize some default behavior if the user did not explcitely script it. 
 
	Subclasses can use this to create a default startup transmission or show 
	a default pane or something like that." 
	 
	^self! !

!GLMBrowser methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
panes 
	"Return an (ordered) collection of the panes used by this browser." 
	 
	self subclassResponsibility! !

GLMBrowser subclass: #GLMExplicitBrowser
	instanceVariableNames: 'panes hiddenPane transmissions jumpstartTransmissions pushedPorts pulledPorts scriptTransmission'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMExplicitBrowser methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
addJumpstart: aTransmission 
	 
	self jumpstartTransmissions addLast: aTransmission! !

!GLMExplicitBrowser methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
addPane: aPane 
	 
	aPane browser: self. 
	self panes addLast: aPane! !

!GLMExplicitBrowser methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
addPull: aSymbol to: aContainedPort 
	"Asks the browser to push changes of aContainedPort to the outer pane's port identified by aSymbol." 
	 
	self pulledPorts 
		add: 
			((GLMPublishedPort new) 
				innerPort: aContainedPort; 
				outerPortName: aSymbol; 
				yourself)! !

!GLMExplicitBrowser methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
addPush: aContainedPort as: aSymbol 
	"Asks the browser to push changes of aContainedPort to the outer pane's port identified by aSymbol." 
	 
	self pushedPorts 
		add: 
			((GLMPublishedPort new) 
				innerPort: aContainedPort; 
				outerPortName: aSymbol; 
				yourself)! !

!GLMExplicitBrowser methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
addTransmission: aTransmission 
	 
	self transmissions addLast: aTransmission! !

!GLMExplicitBrowser methodsFor: 'events' stamp: ' 25/2/09 11:51'!
innerPortEvent: aPortEvent 
	 
	(self pushedPorts select: [:each | each innerPort = aPortEvent port]) 
		do: 
			[:each | (self pane port: each outerPortName) value: aPortEvent value]. 
	aPortEvent hasChanged 
		ifTrue: 
			[(self transmissions select: [:each | each originatesAt: aPortEvent port]) 
				do: [:each | each transmit]]! !

!GLMExplicitBrowser methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
jumpstartTransmissions 
	 
	^jumpstartTransmissions 
		ifNil: [jumpstartTransmissions := OrderedCollection new]! !

!GLMExplicitBrowser methodsFor: 'events' stamp: ' 25/2/09 11:51'!
outerPortEvent: aPortEvent 
	 
	super outerPortEvent: aPortEvent.	"Hack for a jumpstart transmission (we should clean this up)." 
	aPortEvent portName = #entity 
		ifTrue: 
			[self jumpstartTransmissions 
				do: 
					[:each |  
					each 
						clearOrigins; 
						addActiveOrigin: (self pane port: #entity); 
						transmit]]. 
	aPortEvent hasChanged 
		ifTrue: 
			[(self transmissions select: [:each | each originatesAt: aPortEvent port]) 
				do: [:each | each transmit]]. 
	(self pulledPorts 
		select: [:each | each outerPortName = aPortEvent portName]) 
		do: [:each | each innerPort receive: aPortEvent transmission]! !

!GLMExplicitBrowser methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
paneNamed: aSymbol 
	 
	^self panes detect: [:each | each name = aSymbol]! !

!GLMExplicitBrowser methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
panes 
	 
	^panes ifNil: [panes := OrderedCollection new]! !

!GLMExplicitBrowser methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
pulledPorts 
	 
	^pulledPorts ifNil: [pulledPorts := OrderedCollection new]! !

!GLMExplicitBrowser methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
pushedPorts 
	 
	^pushedPorts ifNil: [pushedPorts := OrderedCollection new]! !

!GLMExplicitBrowser methodsFor: 'scripting-private' stamp: ' 25/2/09 11:51'!
resolveDestinationPort: aPortReference 
	 
	^self resolvePort: aPortReference defaultPortName: #entity! !

!GLMExplicitBrowser methodsFor: 'scripting-private' stamp: ' 25/2/09 11:51'!
resolveOriginPort: aPortReference 
	 
	^self resolvePort: aPortReference defaultPortName: #selection! !

!GLMExplicitBrowser methodsFor: 'scripting-private' stamp: ' 25/2/09 11:51'!
resolvePort: aPortReference defaultPortName: aSymbol 
	 
	| tmp | 
	tmp := aPortReference. 
	(tmp isKindOf: GLMPane) ifTrue: [tmp := tmp port: aSymbol]. 
	(tmp isKindOf: GLMPort) ifTrue: [^tmp]. 
	tmp isSymbol ifTrue: [tmp := tmp -> aSymbol]. 
	(tmp isKindOf: Association) 
		ifTrue: 
			[^tmp key = #outer 
				ifTrue: 
					[(GLMParentPort new) 
						presentation: self; 
						name: tmp value; 
						yourself] 
				ifFalse: [(self paneNamed: tmp key) port: tmp value]]. 
	self error: 'Unknown port reference.'! !

!GLMExplicitBrowser methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
transmissions 
	 
	^transmissions ifNil: [transmissions := OrderedCollection new]! !

GLMBrowser subclass: #GLMImplicitBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMPresentation methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
actions 
	 
	^actions ifNil: [actions := OrderedCollection new]! !

!GLMPresentation methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
addAction: anAction 
	 
	self actions addLast: anAction! !

!GLMPresentation methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
beInspectable 
	 
	^isInspectable := true! !

!GLMPresentation methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
condition 
	 
	^condition ifNil: [condition := [true]]! !

!GLMPresentation methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
condition: anObject 
	 
	condition := anObject! !

!GLMPresentation methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
displayValue 
	 
	^self transformation glamourValue: self entity! !

!GLMPresentation methodsFor: 'accessing ports' stamp: ' 25/2/09 11:51'!
entity 
	 
	^(self pane port: #entity) value! !

!GLMPresentation methodsFor: 'accessing ports' stamp: ' 25/2/09 11:51'!
entity: anObject 
	 
	(self pane port: #entity) value: anObject! !

!GLMPresentation methodsFor: 'events' stamp: ' 25/2/09 11:51'!
innerPortEvent: aPortEvent 
	 
	! !

!GLMPresentation methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
isInspectable 
	 
	^isInspectable ifNil: [isInspectable := false]! !

!GLMPresentation methodsFor: 'testing' stamp: ' 25/2/09 11:51'!
matches 
	 
	^(self usesImplicitNotNil 
		ifTrue: [GLMNotNilCondition new glamourValue: self entity] 
		ifFalse: [true]) and: [(self condition glamourValue: self entity) = true]! !

!GLMPresentation methodsFor: 'events' stamp: ' 25/2/09 11:51'!
outerPortEvent: aPortEvent 
	 
	self 
		announce: 
			((GLMContextChanged new) 
				presentation: self; 
				property: aPortEvent portName; 
				value: aPortEvent value; 
				oldValue: aPortEvent oldValue; 
				yourself)! !

!GLMPresentation methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
pane 
	 
	^pane 
		ifNil: 
			[pane := (GLMPane new) 
				addPresentation: self; 
				yourself]! !

!GLMPresentation methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
pane: aPane 
	 
	pane := aPane! !

!GLMPresentation methodsFor: 'copying' stamp: ' 25/2/09 11:51'!
postCopy 
	 
	super postCopy! !

!GLMPresentation methodsFor: 'rendering' stamp: ' 25/2/09 11:51'!
renderGlamorouslyOn: aRenderer 
	 
	^aRenderer renderPresentation: self! !

!GLMPresentation methodsFor: 'accessing ports' stamp: ' 25/2/09 11:51'!
selection 
	 
	^(self pane port: #selection) value! !

!GLMPresentation methodsFor: 'accessing ports' stamp: ' 25/2/09 11:51'!
selection: anObject 
	 
	(self pane port: #selection) value: anObject! !

!GLMPresentation methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
title 
	 
	^title! !

!GLMPresentation methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
title: aString 
	 
	title := aString! !

!GLMPresentation methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
transformation 
	 
	^transformation ifNil: [transformation := #yourself]! !

!GLMPresentation methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
transformation: aBlock 
	 
	transformation := aBlock! !

!GLMPresentation methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
useExplicitNotNil 
	 
	implicitNotNil := false! !

!GLMPresentation methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
useImplicitNotNil 
	 
	implicitNotNil := true! !

!GLMPresentation methodsFor: 'testing' stamp: ' 25/2/09 11:51'!
usesExplicitNotNil 
	 
	^self usesImplicitNotNil not! !

!GLMPresentation methodsFor: 'testing' stamp: ' 25/2/09 11:51'!
usesImplicitNotNil 
	 
	^implicitNotNil ifNil: [implicitNotNil := true]! !

!GLMPresentation methodsFor: 'announcements' stamp: ' 25/2/09 11:51'!
whenContextChanged: aBlock 
	 
	^self when: GLMContextChanged do: aBlock! !

!UndefinedObject methodsFor: '*glamour-core' stamp: ' 25/2/09 11:51'!
glamourPane16x16 
	"Tools.UIMaskEditor new openOnClass: self andSelector: #glamourPane16x16" 
	 
	<resource: #image> 
	^CachedImage 
		on: 
			(Image 
				extent: 16 @ 16 
				depth: 7 
				bitsPerPixel: 8 
				palette: 
					(MappedPalette 
						withColors: 
							(#(#(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4561 5589 7291)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(0 0 0)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(2826 2826 2826)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4304 5621 7355)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4497 5524 7259)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4432 5460 7227)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4240 4240 4240)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(2120 2120 2120)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(3276 4625 6938)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(1959 1959 1959)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(5203 6167 7548)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(2666 2666 2666)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4079 5332 7227)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(5139 6103 7516)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(3147 4497 6874)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(5075 6038 7484)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4304 5332 7163)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(5010 5974 7452)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4240 5235 7163)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(3115 4400 6841)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(224 224 224)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4882 5846 7387)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(5332 5332 5332)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4786 5781 7387)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4721 5749 7323)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(3404 3661 4047)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4497 5749 7387)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(5878 5878 5878)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4400 5717 7355)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4593 5589 7291)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4529 5524 7259)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4304 4304 4304)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4464 5460 7227)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4207 5492 7291)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4368 5396 7227)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(5300 6263 7548)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4111 5428 7291)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(3437 3437 3437)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(5203 6199 7548)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4240 5267 7163)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(5139 6135 7516)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(3212 4561 6938)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(5075 6070 7484)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(3276 3276 3276)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(5010 6006 7452)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(1863 1863 1863)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(289 289 289)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4882 5878 7387)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4753 5749 7323)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(128 128 128)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4657 5685 7323)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4432 5717 7355)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4368 4368 4368)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4593 5621 7291)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4529 5524 7291)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(3404 4689 6970)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4464 5492 7227)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4207 4207 4207)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(5300 6295 7548)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4304 5364 7195)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(5171 6135 7516)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(3950 5203 7227)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(5043 6006 7452)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(2987 4304 6809)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4946 5942 7452)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(3822 5107 7130)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(1381 1638 2120)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4818 5814 7387)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4753 5749 7355)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(1541 1541 1573)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(1606 1606 1606)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4689 5685 7323)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4625 5621 7291)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(1445 1445 1445)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(32 32 32)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4529 5557 7291)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4464 5492 7259)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4400 5428 7227)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(1284 1284 1284)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4143 5460 7291)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(5235 6231 7548)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(3276 4561 6938)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4336 5364 7195)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4272 5300 7163)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4207 5235 7130)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(3051 4400 6841)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(2537 2537 2537)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(5043 6038 7452)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(2987 4304 6841)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(2890 4272 6809)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(6777 6777 6777)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(3758 5043 7130)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4818 5846 7387)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4753 5781 7355)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(8191 8191 8191)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(3597 4946 7066)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4689 5717 7323)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(3693 4978 7098)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(96 96 96)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(3469 4818 7002)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4336 4336 4336)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4304 5589 7355)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4272 5524 7291)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(5267 6231 7548)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(6295 6295 6295)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(5203 6167 7516)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(5107 6103 7516)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(5075 6038 7452)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4978 5974 7452)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(321 321 321)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(3147 3147 3147)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4914 5910 7420)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(2248 2409 2666)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4850 5846 7387)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4336 4529 4818)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4786 5781 7355)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(2923 4272 6809)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4400 4400 4400)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4657 5621 7323))) 
								collect: 
									[:each |  
									(each at: 1) value 
										perform: (each at: 2) 
										withArguments: (each at: 3)])) 
				usingBits: 
					(ByteArray fromPackedString: 
							'W%9^W%9^W%9^W%9^W%9^W%9$YFQ^W%9^W%9^W",+[%9^YE(FF#L\@6U&HRQ.Z@I^W!!<9\#)''TF$(Z&,,FUY0W%9^GBMPB#0MJ#9,[7E[W%9^W L&ZP4*U61/ETMDW59^W%9&JF)WDT@/WE4XL&M^W%9^S0<,PF=1E3AGRA47W%9^W 1,[7ECQD]6GT-LTU9^W%8=K4M]XCH5R0PESP9^W%9^PWLXQ4 @G"AMT!!AUW%9^W&EG]!!46ND4"N5LRO59^W \I\D-LARIRT2]TP!!PTW%8-F4THJP8SUU!!4VQPVX%9^Q$%NW%9^W%9^W%81R E^W%9^W%9^W%9^W%9^W%9^W @a'))! !

!UndefinedObject methodsFor: '*glamour-core' stamp: ' 25/2/09 11:51'!
glamourPane16x16mask 
	"UIMaskEditor new openOnClass: self andSelector: #glamourPane16x16mask" 
	 
	<resource: #image> 
	^CachedImage 
		on: 
			(Image 
				extent: 16 @ 16 
				depth: 1 
				bitsPerPixel: 1 
				palette: CoveragePalette monoMaskPalette 
				usingBits: 
					#[0 0 0 0 112 14 0 0 127 254 0 0 127 254 0 0 63 252 0 0 63 252 0 0 63 252 0 0 63 252 0 0 63 252 0 0 63 252 0 0 63 252 0 0 63 252 0 0 127 254 0 0 127 254 0 0 112 14 0 0 0 0 0 0])! !

!UndefinedObject methodsFor: '*glamour-core' stamp: ' 25/2/09 11:51'!
glamourPresentation16x16 
	"Tools.UIMaskEditor new openOnClass: self andSelector: #glamourPresentation16x16" 
	 
	<resource: #image> 
	^CachedImage 
		on: 
			(Image 
				extent: 16 @ 16 
				depth: 7 
				bitsPerPixel: 8 
				palette: 
					(MappedPalette 
						withColors: 
							(#(#(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(3404 4753 7002)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(7227 7227 7227)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4432 5460 7227)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(7066 7066 7066)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(6360 6360 6360)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4111 5428 7259)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(3147 4497 6874)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(3115 4400 6841)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4240 5235 7163)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(6199 6199 6199)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(6906 6906 6906)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(3533 4818 7002)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4593 5589 7291)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(7998 7998 7998)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4529 5524 7259)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(7291 7291 7291)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(6424 6424 6424)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4368 5396 7227)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(3212 4561 6938)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4079 5364 7227)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(6263 6263 6263)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(6970 6970 6970)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4175 5203 7130)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(6809 6809 6809)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(7355 7355 7355)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(6649 6649 6649)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(8062 8062 8062)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4657 5685 7323)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(3404 4689 6970)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4464 5492 7227)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(7195 7195 7195)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(3308 4657 6938)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(6327 6327 6327)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(6167 6167 6167)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(3822 5107 7130)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(2826 4207 6745)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4818 5814 7387)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4753 5749 7355)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(8126 8126 8126)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(6713 6713 6713)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4625 5621 7291)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(6552 6552 6552)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4529 5557 7291)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4400 5428 7227)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(7098 7098 7098)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4336 5364 7195)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4272 5300 7163)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4015 5332 7227)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(3950 5235 7227)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(3051 4400 6841)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(2987 4304 6841)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(2890 4272 6809)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(6070 6070 6070)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(2858 4207 6745)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(3693 4978 7098)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(8191 8191 8191)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(3597 4946 7066)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4689 5717 7323)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(6617 6617 6617)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(8030 8030 8030)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(6456 6456 6456)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(7163 7163 7163)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(6295 6295 6295)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4304 5300 7163)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(7002 7002 7002)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4978 5974 7452)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(6135 6135 6135)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4914 5910 7420)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(3758 5075 7130)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4850 5846 7387)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(2858 4240 6745)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4786 5781 7355)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(5974 5974 5974)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(8094 8094 8094))) 
								collect: 
									[:each |  
									(each at: 1) value 
										perform: (each at: 2) 
										withArguments: (each at: 3)])) 
				usingBits: 
					(ByteArray fromPackedString: 
							'M3\7M3\7M3\7M3\7M3\7M3\7M3\7M3\7M3\7M3\7M3\7FC4=OPLJB!!\YFS\7M3\7M34&I"X&I"X&RR$7M3\7M3\=I!!(ZF!!(ZN4$DM3\7M3\7KBXZF!!(;N3-IH@T/LBH7M0(&F#,;N3,MRTIAP2P6M3\JI#,;N04MCT%BQT\9B3\7E4%IRT%IRT%IMBT[CA07M1$:JPPDO$IBMD (J!!4RM3\7M3\SPTL$IQ,LC HQA3\7M3\7LDUGNR *GR,-K#H7M3\7M4P%F00N@!!D?BAYFM3\7M3\8B0@_D X1L#L5H3\7M3\7M3\7M3\7M3\7M3\7M3\7M3\7M3\7M3\7M3\7M0@a'))! !

!UndefinedObject methodsFor: '*glamour-core' stamp: ' 25/2/09 11:51'!
glamourPresentation16x16mask 
	"Tools.UIMaskEditor new openOnClass: self andSelector: #glamourPresentation16x16mask" 
	 
	<resource: #image> 
	^CachedImage 
		on: 
			(Image 
				extent: 16 @ 16 
				depth: 1 
				bitsPerPixel: 1 
				palette: CoveragePalette monoMaskPalette 
				usingBits: 
					#[0 0 0 0 0 0 0 0 127 224 0 0 127 224 0 0 127 224 0 0 127 254 0 0 127 254 0 0 127 254 0 0 127 254 0 0 127 254 0 0 15 254 0 0 15 254 0 0 15 254 0 0 15 254 0 0 0 0 0 0 0 0 0 0])! !

!UndefinedObject methodsFor: '*glamour-core' stamp: ' 25/2/09 11:51'!
glamourTransmission16x16 
	"Tools.UIMaskEditor new openOnClass: self andSelector: #glamourPane16x16" 
	 
	<resource: #image> 
	^CachedImage 
		on: 
			(Image 
				extent: 16 @ 16 
				depth: 7 
				bitsPerPixel: 8 
				palette: 
					(MappedPalette 
						withColors: 
							(#(#(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(2184 4464 1959)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(5332 6841 5043)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(2505 4850 2248)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(3983 6103 3822)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(3147 5653 2794)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4786 6552 4561)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4272 6263 4047)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(3115 5235 2923)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(2344 4464 2152)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(3661 6327 3276)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(2666 4850 2441)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(2923 5396 2633)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(3693 5749 3501)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(2505 4882 2248)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(2826 5267 2537)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4400 6488 4047)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4400 6360 4175)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(3244 5364 3019)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(5203 6809 4914)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(2441 4657 2216)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(2409 4753 2152)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(3950 5942 3726)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(2730 5139 2441)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(1670 3822 1509)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(3051 5524 2730)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4689 6488 4432)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(2312 4625 2055)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(3469 5621 3212)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(3854 5846 3597)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(5075 6713 4818)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(1573 3693 1413)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(1895 4079 1702)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4946 6649 4689)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(3565 6199 3212)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4015 6135 3822)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(3147 5685 2826)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(3469 6070 3115)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(2441 4721 2184)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(8191 8191 8191)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(3147 5267 2923)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(1991 4240 1798)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(3372 5942 3019)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(3437 5814 3083)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(3854 5878 3597)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(5492 6938 5203)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(2955 5428 2633)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(3276 5814 2923)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(2537 4882 2280)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(1798 3983 1606)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(3629 5717 3340)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(1702 3854 1509)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4978 6649 4721)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(3726 5846 3469)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(2858 5300 2569)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(2152 4304 1959)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(3533 5974 3212)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(2441 4786 2184)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4336 6295 4079)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(1702 3854 1541)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(2023 4272 1798)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(2344 4657 2087)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(3693 6360 3340)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(2666 5043 2376)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4175 6231 3983)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(1606 3726 1445)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(3597 6231 3244)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(3661 6103 3308)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(1509 3597 1349)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4432 6552 4079)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4497 6360 4207)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4850 6617 4593)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(3629 5685 3437)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(1413 3469 1252)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(2762 5203 2473)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(3083 5589 2762)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(2344 4657 2120)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(1606 3758 1445)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4593 6552 4272)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(3437 5492 3180)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(5396 6906 5107)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4111 6199 3790)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4432 6552 4111)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4464 6392 4240)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(5267 6809 5010)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(3918 6103 3758)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4336 6327 4111)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(1734 3886 1541)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(2055 4272 1830)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4753 6520 4497)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4240 6327 3886)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4625 6456 4368)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(2569 4946 2312)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(3790 5846 3501)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4079 6167 3886)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(2890 5332 2601)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(1509 3629 1381)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(2152 4432 1927)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(3661 5781 3372)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4882 6617 4625)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(2280 4497 2087)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(2280 4561 2023)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(3790 5878 3501)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(5428 6906 5139)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(2794 5235 2505)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(1734 3918 1573)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(3115 5621 2794)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(3565 5621 3340)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(5171 6777 4882)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(5557 7002 5267)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4240 6263 4015)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(1638 3790 1477)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4625 6488 4400)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(3019 5460 2730)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(3019 5492 2698)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(3437 5524 3244)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(3629 6295 3276)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(2923 5364 2601)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4497 6424 4272)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(1863 4047 1670)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4368 6327 4175)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(4786 6552 4529)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(3437 6038 3083)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(3019 5524 2698)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(3661 6295 3276)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(5460 6906 5171)) #(ColorValue  
								#scaledRed:scaledGreen:scaledBlue: #(3244 5781 2890))) 
								collect: 
									[:each |  
									(each at: 1) value 
										perform: (each at: 2) 
										withArguments: (each at: 3)])) 
				usingBits: 
					(ByteArray fromPackedString: 
							'I"X&I"X&I"X&I"X&I"X&I"X&I %AI"X&I"X&KP8&I"X&I''-QC7$&I"X&B51!!V2X&OW-D[G1Y_PQ:]CP3Q$8Z@GL!!SR1&TF%1W$$1X''!!*XE\&IDIO@T(&I"X&CU!!/D3,&I"$7T1I0MRX&@"UZ]VL_I"X.J&,]YQX&I$,QT''\6ZBX&H1!!EH@T[NC0''NUUGU$0&I"Y4Y2,Y[1T\]64GN$@&I"X&I#8/E@0PNWH0L!!8&I"X&I"X&I&PJA#<HE2X&I"X&I"X&I"X&JBHC["X&I"X&I"X&I"X&I''X"UE<&I"X&I"X&I"X&I"YVSDMHI"X&I"X&I"X&I"X&I"X&I"X&I"X&I @a'))! !

!UndefinedObject methodsFor: '*glamour-core' stamp: ' 25/2/09 11:51'!
glamourTransmission16x16mask 
	"Tools.UIMaskEditor new openOnClass: self andSelector: #glamourPane16x16" 
	 
	<resource: #image> 
	^CachedImage 
		on: 
			(Image 
				extent: 16 @ 16 
				depth: 1 
				bitsPerPixel: 1 
				palette: CoveragePalette monoMaskPalette 
				usingBits: 
					#[0 0 0 0 24 24 0 0 60 60 0 0 255 255 0 0 255 255 0 0 124 62 0 0 126 126 0 0 126 126 0 0 127 254 0 0 63 252 0 0 31 248 0 0 7 224 0 0 3 192 0 0 3 192 0 0 3 192 0 0 0 0 0 0])! !

OrderedCollection variableSubclass: #GLMMultiValue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

Announcement subclass: #GLMContextChanged
	instanceVariableNames: 'presentation property value oldValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMContextChanged methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
oldValue 
	 
	^oldValue! !

!GLMContextChanged methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
oldValue: anObject 
	 
	oldValue := anObject! !

!GLMContextChanged methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
presentation 
	 
	^presentation! !

!GLMContextChanged methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
presentation: aPresentation 
	 
	presentation := aPresentation! !

!GLMContextChanged methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
property 
	 
	^property! !

!GLMContextChanged methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
property: aSymbol 
	 
	property := aSymbol! !

!GLMContextChanged methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
value 
	 
	^value! !

!GLMContextChanged methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
value: anObject 
	 
	value := anObject! !

Announcement subclass: #GLMMatchingPresentationsChanged
	instanceVariableNames: 'pane oldMatchingPresentations'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMMatchingPresentationsChanged methodsFor: 'accessing-convenience' stamp: ' 25/2/09 11:51'!
matchingPresentations 
	"The presentations that match now." 
	 
	^self pane matchingPresentations! !

!GLMMatchingPresentationsChanged methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
oldMatchingPresentations 
	"The presentations that matched before this announcement." 
	 
	^oldMatchingPresentations! !

!GLMMatchingPresentationsChanged methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
oldMatchingPresentations: aCollection 
	"The presentations that matched before this announcement." 
	 
	oldMatchingPresentations := aCollection! !

!GLMMatchingPresentationsChanged methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
pane 
	"The pane on which the matching presentations changed." 
	 
	^pane! !

!GLMMatchingPresentationsChanged methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
pane: aPane 
	"The pane on which the matching presentations changed." 
	 
	pane := aPane! !

Announcement subclass: #GLMPresentationsChanged
	instanceVariableNames: 'pane oldPresentations'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMPresentationsChanged methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
oldPresentations 
	"The presentations that were present on the pane before the change." 
	 
	^oldPresentations! !

!GLMPresentationsChanged methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
oldPresentations: aCollection 
	"The presentations that were present on the pane before the change." 
	 
	oldPresentations := aCollection! !

!GLMPresentationsChanged methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
pane 
	"The pane on which the presentations changed." 
	 
	^pane! !

!GLMPresentationsChanged methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
pane: aPane 
	"The pane on which the presentations changed." 
	 
	pane := aPane! !

!GLMPresentationsChanged methodsFor: 'accessing-convenience' stamp: ' 25/2/09 11:51'!
presentations 
	"The presentationt that are currently present on the pane." 
	 
	^self pane presentations! !

Object subclass: #GLMAction
	instanceVariableNames: 'action title shortcut position category'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMAction commentStamp: '<historical>' prior: 0!
Actions are elements of behavior that are executed upon a keyboard shortcut or other event.

Instances of Action are stored and maintained by Presentations. The exact representation is determined by the renderer, but actions can define a keyboard shortcut that should trigger the action or a title, category and position to be able to use the action as a context menu item.!

!GLMAction methodsFor: 'public interface' stamp: ' 25/2/09 11:51'!
actOn: aPresentation 
	 
	^self action glamourValueWithArgs: (Array with: aPresentation)! !

!GLMAction methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
action 
	"The code that should be executed when this action is triggered." 
	 
	^action! !

!GLMAction methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
action: aBlock 
	"The code that should be executed when this action is triggered. 
 
	The block can take optional arguments, the first will always be the 
	presentation on which this action was triggered." 
	 
	action := aBlock! !

!GLMAction methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
category 
	"The name of the category that should be used when this action is displayed in a context menu." 
	 
	^category! !

!GLMAction methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
category: aString 
	"The name of the category that should be used when this action is displayed in a context menu." 
	 
	category := aString! !

!GLMAction methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
position 
	"The relative position within a context menu." 
	 
	^position! !

!GLMAction methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
position: anInteger 
	"The relative position within a context menu." 
	 
	position := anInteger! !

!GLMAction methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
shortcut 
	"Shortcut character that this action should be triggered with when the focus rests on the corresponding presentation. 
	Modifiers are platform specific an can not be defined." 
	 
	^shortcut! !

!GLMAction methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
shortcut: aCharacter 
	"Shortcut character that this action should be triggered with when the focus rests on the corresponding presentation. 
	Modifiers are platform specific an can not be defined." 
	 
	shortcut := aCharacter! !

!GLMAction methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
title 
	"Title that this action should use in a context menu." 
	 
	^title! !

!GLMAction methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
title: anObject 
	"Title that this action should use in a context menu." 
	 
	title := anObject! !

Object subclass: #GLMBundleOrigin
	instanceVariableNames: 'port active'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMBundleOrigin commentStamp: '<historical>' prior: 0!
Used by BundleTransmission to annotate its originating ports whether they are active or passive.

When a BundleTransmission consideres a port as active, the browser will trigger it when the corresponding port changes.!

!GLMBundleOrigin methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
beActive 
	 
	active := true! !

!GLMBundleOrigin methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
bePassive 
	 
	active := false! !

!GLMBundleOrigin methodsFor: 'testing' stamp: ' 25/2/09 11:51'!
isActive 
	 
	^active ifNil: [active := true]! !

!GLMBundleOrigin methodsFor: 'testing' stamp: ' 25/2/09 11:51'!
isPassive 
	 
	^self isActive not! !

!GLMBundleOrigin methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
port 
	 
	^port! !

!GLMBundleOrigin methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
port: aPort 
	 
	port := aPort! !

!GLMBundleOrigin methodsFor: 'accessing-convenience' stamp: ' 25/2/09 11:51'!
value 
	 
	^self port value! !

Object subclass: #GLMPort
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

GLMPort subclass: #GLMBoundPort
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMBoundPort methodsFor: 'comparing' stamp: ' 25/2/09 11:51'!
= anObject 
	"Compare this port with another for equality. 
 
	This is used to compare ParentPorts with PanePorts where the earlier is a proxy for the latter." 
	 
	^((anObject isKindOf: GLMBoundPort) and: [self pane = anObject pane]) 
		and: [self name = anObject name]! !

!GLMBoundPort methodsFor: 'testing' stamp: ' 25/2/09 11:51'!
hasPane 
	 
	^self pane notNil! !

!GLMBoundPort methodsFor: 'comparing' stamp: ' 25/2/09 11:51'!
hash 
	"Ports which are equal should return hash. 
 
	Since equality is used only for matching port proxies (ParentPort) with 
	their actual port, the hash function is overridden only in ParentPort." 
	 
	^super hash! !

!GLMBoundPort methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
pane 
	 
	self subclassResponsibility! !

GLMBoundPort subclass: #GLMPanePort
	instanceVariableNames: 'pane value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMPanePort commentStamp: '<historical>' prior: 0!
A port that belongs to a pane.

Bound ports have a few special characteristics in comparison to their superclass. For one, they don't just assign a value to themselves using #value: but rather generate a transmission that set the value so that the pane can handle the transmission and forward it to other ports if necessary, depending on the policy of the containing browser.!

!GLMPanePort methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
pane 
	 
	^pane! !

!GLMPanePort methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
pane: aPane 
	 
	pane := aPane! !

!GLMPanePort methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
receive: aTransmission 
	 
	| oldValue | 
	oldValue := self value. 
	self pane 
		notingPresentationChangeDo: 
			[value := aTransmission value. 
			self pane 
				portEvent: 
					((GLMPortEvent new) 
						port: self; 
						transmission: aTransmission; 
						oldValue: oldValue; 
						yourself)]! !

!GLMPanePort methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
value 
	 
	^value! !

!GLMPanePort methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
value: anObject 
	 
	(GLMSimpleTransmission new) 
		origin: (GLMSimplePort new value: anObject); 
		destination: self; 
		transmit! !

GLMBoundPort subclass: #GLMParentPort
	instanceVariableNames: 'presentation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMParentPort methodsFor: 'comparing' stamp: ' 25/2/09 11:51'!
hash 
	 
	^self port hash! !

!GLMParentPort methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
pane 
	 
	^self presentation pane! !

!GLMParentPort methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
port 
	 
	^self pane port: self name! !

!GLMParentPort methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
presentation 
	 
	^presentation! !

!GLMParentPort methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
presentation: aPresentation 
	 
	presentation := aPresentation! !

!GLMParentPort methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
receive: aTransmission 
	 
	self port receive: aTransmission! !

!GLMParentPort methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
value 
	 
	^self port value! !

!GLMParentPort methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
value: anObject 
	 
	self port value: anObject! !

!GLMPort methodsFor: 'testing' stamp: ' 25/2/09 11:51'!
hasPane 
	 
	^false! !

!GLMPort methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
name 
	 
	^name! !

!GLMPort methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
name: aSymbol 
	 
	name := aSymbol! !

!GLMPort methodsFor: 'printing' stamp: ' 25/2/09 11:51'!
printOn: aStream 
	 
	aStream 
		nextPutAll: 'Port (name->'; 
		nextPutAll: self name printString; 
		nextPutAll: ' value->'; 
		nextPutAll: self value printString; 
		nextPut: $)! !

!GLMPort methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
receive: aTransmission 
	 
	self subclassResponsibility! !

!GLMPort methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
value 
	 
	self subclassResponsibility! !

!GLMPort methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
value: anObject 
	 
	self subclassResponsibility! !

GLMPort subclass: #GLMSimplePort
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMSimplePort methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
receive: aTransmission 
	 
	self value: aTransmission value! !

!GLMSimplePort methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
value 
	 
	^value! !

!GLMSimplePort methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
value: anObject 
	 
	value := anObject! !

Object subclass: #GLMPortEvent
	instanceVariableNames: 'port transmission oldValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMPortEvent methodsFor: 'testing' stamp: ' 25/2/09 11:51'!
hasChanged 
	"Answer whether the port value changed due to the event." 
	 
	^self value ~= self oldValue! !

!GLMPortEvent methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
oldValue 
	 
	^oldValue! !

!GLMPortEvent methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
oldValue: anObject 
	 
	oldValue := anObject! !

!GLMPortEvent methodsFor: 'accessing-convenience' stamp: ' 25/2/09 11:51'!
pane 
	 
	^self port pane! !

!GLMPortEvent methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
port 
	 
	^port! !

!GLMPortEvent methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
port: aPort 
	 
	port := aPort! !

!GLMPortEvent methodsFor: 'accessing-convenience' stamp: ' 25/2/09 11:51'!
portName 
	 
	^self port name! !

!GLMPortEvent methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
transmission 
	 
	^transmission! !

!GLMPortEvent methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
transmission: aTransmission 
	 
	transmission := aTransmission! !

!GLMPortEvent methodsFor: 'accessing-convenience' stamp: ' 25/2/09 11:51'!
value 
	 
	^self port value! !

Object subclass: #GLMPublishedPort
	instanceVariableNames: 'outerPortName innerPort'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMPublishedPort methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
innerPort 
	 
	^innerPort! !

!GLMPublishedPort methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
innerPort: aPort 
	 
	innerPort := aPort! !

!GLMPublishedPort methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
outerPortName 
	 
	^outerPortName! !

!GLMPublishedPort methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
outerPortName: aSymbol 
	 
	outerPortName := aSymbol! !

Object subclass: #GLMRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMRenderer methodsFor: 'rendering' stamp: ' 25/2/09 11:51'!
doOpen: aUI 
	 
	^self subclassResponsibility! !

!GLMRenderer methodsFor: 'rendering' stamp: ' 25/2/09 11:51'!
open: aRenderable 
	 
	^self doOpen: (self render: aRenderable)! !

!GLMRenderer methodsFor: 'rendering' stamp: ' 25/2/09 11:51'!
render: aRenderable 
	 
	^aRenderable renderGlamorouslyOn: self! !

!GLMRenderer methodsFor: 'rendering' stamp: ' 25/2/09 11:51'!
renderPane: aPane 
	 
	^nil! !

!GLMRenderer methodsFor: 'rendering' stamp: ' 25/2/09 11:51'!
renderPresentation: aPresentation 
	 
	^nil! !

Object subclass: #GLMTransmission
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

GLMTransmission subclass: #GLMBundleTransmission
	instanceVariableNames: 'presentations destination origins'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMBundleTransmission methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
activeOrigins 
	 
	^(self bundleOrigins select: [:each | each isActive]) 
		collect: [:each | each port]! !

!GLMBundleTransmission methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
addActiveOrigin: aPort 
	 
	self bundleOrigins 
		add: 
			((GLMBundleOrigin new) 
				port: aPort; 
				beActive; 
				yourself)! !

!GLMBundleTransmission methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
addPassiveOrigin: aPort 
	 
	self bundleOrigins 
		add: 
			((GLMBundleOrigin new) 
				port: aPort; 
				bePassive; 
				yourself)! !

!GLMBundleTransmission methodsFor: 'accessing-convenience' stamp: ' 25/2/09 11:51'!
addPresentation: aPresentation 
	 
	self presentations addLast: aPresentation! !

!GLMBundleTransmission methodsFor: 'accessing-convenience' stamp: ' 25/2/09 11:51'!
addPresentations: aCollection 
	 
	aCollection do: [:each | self addPresentation: each]! !

!GLMBundleTransmission methodsFor: 'private accessing' stamp: ' 25/2/09 11:51'!
bundleOrigins 
	 
	^origins ifNil: [origins := OrderedCollection new]! !

!GLMBundleTransmission methodsFor: 'private' stamp: ' 25/2/09 11:51'!
clearOrigins 
	 
	origins := nil! !

!GLMBundleTransmission methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
destination 
	 
	^destination! !

!GLMBundleTransmission methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
destination: aPort 
	 
	destination := aPort! !

!GLMBundleTransmission methodsFor: 'testing' stamp: ' 25/2/09 11:51'!
originatesAt: aPort 
	 
	^self activeOrigins includes: aPort! !

!GLMBundleTransmission methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
origins 
	 
	^self bundleOrigins collect: [:each | each port]! !

!GLMBundleTransmission methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
passiveOrigins 
	 
	^(self bundleOrigins select: [:each | each isPassive]) 
		collect: [:each | each port]! !

!GLMBundleTransmission methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
presentations 
	 
	^presentations ifNil: [presentations := OrderedCollection new]! !

!GLMBundleTransmission methodsFor: 'transmitting' stamp: ' 25/2/09 11:51'!
transmit 
	 
	self destination hasPane 
		ifTrue: 
			[self destination pane clear. 
			self destination pane addPresentations: self presentations]. 
	self destination receive: self! !

!GLMBundleTransmission methodsFor: 'transmitting' stamp: ' 25/2/09 11:51'!
value 
	 
	^self origins size = 1 
		ifTrue: [self origins first value] 
		ifFalse: 
			[GLMMultiValue withAll: (self origins collect: [:each | each value])]! !

GLMTransmission subclass: #GLMSimpleTransmission
	instanceVariableNames: 'origin destination'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMSimpleTransmission methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
destination 
	 
	^destination! !

!GLMSimpleTransmission methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
destination: aPort 
	 
	destination := aPort! !

!GLMSimpleTransmission methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
origin 
	 
	^origin! !

!GLMSimpleTransmission methodsFor: 'accessing' stamp: ' 25/2/09 11:51'!
origin: aPort 
	 
	origin := aPort! !

!GLMSimpleTransmission methodsFor: 'testing' stamp: ' 25/2/09 11:51'!
originatesAt: aPort 
	 
	^self origin = aPort! !

!GLMSimpleTransmission methodsFor: 'transmitting' stamp: ' 25/2/09 11:51'!
transmit 
	 
	self destination receive: self! !

!GLMSimpleTransmission methodsFor: 'transmitting' stamp: ' 25/2/09 11:51'!
value 
	 
	^self origin value! !

!GLMTransmission methodsFor: 'testing' stamp: ' 25/2/09 11:51'!
originatesAt: aPort 
	 
	^false! !

!GLMTransmission methodsFor: 'transmitting' stamp: ' 25/2/09 11:51'!
transmit 
	 
	self subclassResponsibility! !

!GLMTransmission methodsFor: 'transmitting' stamp: ' 25/2/09 11:51'!
value 
	 
	self subclassResponsibility! !
